#include <avr/interrupt.h>
#include <ff_avr_sd/diskio_mmc.h>
#include "application.hpp"


static Voltmeter::Application application;


ISR(ADC_vect)
{
    application.AdcIntHandler();
}


ISR(TIMER1_OVF_vect)
{
    application.Timer1OverflowIntHandler();
}


ISR(TIMER2_OVF_vect)
{
    mmc_disk_timerproc();
    application.Timer2OverflowIntHandler();
}


int main()
{
    application.Main();
    while (true);
}