#pragma once

#include <stdint.h>

namespace Utils
{
    template<int N>
    struct UIntLeastS
    {
        using T = uint64_t;
    };

    template<>
    struct UIntLeastS<1>
    {
        using T = uint8_t;
    };

    template<>
    struct UIntLeastS<2>
    {
        using T = uint16_t;
    };

    template<>
    struct UIntLeastS<3>
    {
        using T = uint32_t;
    };

    template<>
    struct UIntLeastS<4>
    {
        using T = uint32_t;
    };

    template<int N>
    using UIntLeast = typename UIntLeastS<(N+7)/8>::T;

    template<int N>
    struct IntLeastS
    {
        using T = uint64_t;
    };

    template<>
    struct IntLeastS<1>
    {
        using T = uint8_t;
    };

    template<>
    struct IntLeastS<2>
    {
        using T = uint16_t;
    };

    template<>
    struct IntLeastS<3>
    {
        using T = uint32_t;
    };

    template<>
    struct IntLeastS<4>
    {
        using T = uint32_t;
    };

    template<int N>
    using IntLeast = typename IntLeastS<(N+7)/8>::T;
}